#pragma once

#include <afxtempl.h>


template<class TYPE, class ARG_TYPE = const TYPE&>
class ClistBj : public CList<TYPE, ARG_TYPE>
{
	typedef bool(*pSort_FUNC)(const TYPE &Min, const TYPE &Max);

public:
	// 
	void Sort(pSort_FUNC byFunc)
	{
		CNode *pOutLoop = m_pNodeHead;
		while (NULL != pOutLoop)
		{
			CNode *pMin = pOutLoop;
			CNode *pInLoop = pMin->pNext;
			while (NULL != pInLoop)
			{
				if (false == byFunc(pMin->data, pInLoop->data))
				{
					pMin = pInLoop;
				}
				pInLoop = pInLoop->pNext;
			}

			if (pMin != pOutLoop)
			{
				TYPE temp = pMin->data;
				pMin->data = pOutLoop->data;
				pOutLoop->data = temp;
			}
			pOutLoop = pOutLoop->pNext;
		}
	}

	// 
	POSITION* SortMalloc(pSort_FUNC byFunc)
	{
		CNode **ps = new CNode *[m_nCount + 1];
		ps[m_nCount] = NULL;

		CNode *pLoop = m_pNodeHead;
		int nIndex = 0;
		while (NULL != pLoop)
		{
			ps[nIndex] = pLoop;
			
			++nIndex;
			pLoop = pLoop->pNext;
		}

		int nOutLoop = 0;
		while (nOutLoop < m_nCount - 1)
		{
			int nMin = nOutLoop;
			int nInLoop = nMin + 1;

			while (nInLoop < m_nCount)
			{
				if (false == byFunc(ps[nMin]->data, ps[nInLoop]->data))
				{
					nMin = nInLoop;
				}
				++nInLoop;
			}

			if (nMin != nOutLoop)
			{
				CNode *temp = ps[nMin];
				ps[nMin] = ps[nOutLoop];
				ps[nOutLoop] = temp;
			}
			++nOutLoop;
		}

		return (POSITION*)ps;
	}
};